<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>FinalRequestProcessor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">FinalRequestProcessor.java</span></div><h1>FinalRequestProcessor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.List;

import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.MultiResponse;
import org.apache.zookeeper.ZooDefs;
import org.apache.zookeeper.KeeperException.Code;
import org.apache.zookeeper.KeeperException.SessionMovedException;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Stat;
import org.apache.zookeeper.proto.CreateResponse;
import org.apache.zookeeper.proto.ExistsRequest;
import org.apache.zookeeper.proto.ExistsResponse;
import org.apache.zookeeper.proto.GetACLRequest;
import org.apache.zookeeper.proto.GetACLResponse;
import org.apache.zookeeper.proto.GetChildren2Request;
import org.apache.zookeeper.proto.GetChildren2Response;
import org.apache.zookeeper.proto.GetChildrenRequest;
import org.apache.zookeeper.proto.GetChildrenResponse;
import org.apache.zookeeper.proto.GetDataRequest;
import org.apache.zookeeper.proto.GetDataResponse;
import org.apache.zookeeper.proto.ReplyHeader;
import org.apache.zookeeper.proto.SetACLResponse;
import org.apache.zookeeper.proto.SetDataResponse;
import org.apache.zookeeper.proto.SetWatches;
import org.apache.zookeeper.proto.SyncRequest;
import org.apache.zookeeper.proto.SyncResponse;
import org.apache.zookeeper.server.DataTree.ProcessTxnResult;
import org.apache.zookeeper.server.ZooKeeperServer.ChangeRecord;
import org.apache.zookeeper.txn.CreateSessionTxn;
import org.apache.zookeeper.txn.ErrorTxn;
import org.apache.zookeeper.txn.TxnHeader;

import org.apache.zookeeper.MultiTransactionRecord;
import org.apache.zookeeper.Op;
import org.apache.zookeeper.OpResult;
import org.apache.zookeeper.OpResult.CheckResult;
import org.apache.zookeeper.OpResult.CreateResult;
import org.apache.zookeeper.OpResult.DeleteResult;
import org.apache.zookeeper.OpResult.SetDataResult;
import org.apache.zookeeper.OpResult.ErrorResult;

/**
 * This Request processor actually applies any transaction associated with a
 * request and services any queries. It is always at the end of a
 * RequestProcessor chain (hence the name), so it does not have a nextProcessor
 * member.
 *
 * This RequestProcessor counts on ZooKeeperServer to populate the
 * outstandingRequests member of ZooKeeperServer.
 */
public class FinalRequestProcessor implements RequestProcessor {
<span class="fc" id="L78">    private static final Logger LOG = LoggerFactory.getLogger(FinalRequestProcessor.class);</span>

    ZooKeeperServer zks;

<span class="fc" id="L82">    public FinalRequestProcessor(ZooKeeperServer zks) {</span>
<span class="fc" id="L83">        this.zks = zks;</span>
<span class="fc" id="L84">    }</span>

    public void processRequest(Request request) {
<span class="pc bpc" id="L87" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L88">            LOG.debug(&quot;Processing request:: &quot; + request);</span>
        }
        // request.addRQRec(&quot;&gt;final&quot;);
<span class="fc" id="L91">        long traceMask = ZooTrace.CLIENT_REQUEST_TRACE_MASK;</span>
<span class="fc bfc" id="L92" title="All 2 branches covered.">        if (request.type == OpCode.ping) {</span>
<span class="fc" id="L93">            traceMask = ZooTrace.SERVER_PING_TRACE_MASK;</span>
        }
<span class="pc bpc" id="L95" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L96">            ZooTrace.logRequest(LOG, traceMask, 'E', request, &quot;&quot;);</span>
        }
<span class="fc" id="L98">        ProcessTxnResult rc = null;</span>
<span class="fc" id="L99">        synchronized (zks.outstandingChanges) {</span>
<span class="fc bfc" id="L100" title="All 2 branches covered.">            while (!zks.outstandingChanges.isEmpty()</span>
<span class="fc bfc" id="L101" title="All 2 branches covered.">                    &amp;&amp; zks.outstandingChanges.get(0).zxid &lt;= request.zxid) {</span>
<span class="fc" id="L102">                ChangeRecord cr = zks.outstandingChanges.remove(0);</span>
<span class="pc bpc" id="L103" title="1 of 2 branches missed.">                if (cr.zxid &lt; request.zxid) {</span>
<span class="nc" id="L104">                    LOG.warn(&quot;Zxid outstanding &quot;</span>
                            + cr.zxid
                            + &quot; is less than current &quot; + request.zxid);
                }
<span class="fc bfc" id="L108" title="All 2 branches covered.">                if (zks.outstandingChangesForPath.get(cr.path) == cr) {</span>
<span class="fc" id="L109">                    zks.outstandingChangesForPath.remove(cr.path);</span>
                }
<span class="fc" id="L111">            }</span>
<span class="fc bfc" id="L112" title="All 2 branches covered.">            if (request.hdr != null) {</span>
<span class="fc" id="L113">               TxnHeader hdr = request.hdr;</span>
<span class="fc" id="L114">               Record txn = request.txn;</span>

<span class="fc" id="L116">               rc = zks.processTxn(hdr, txn);</span>
            }
            // do not add non quorum packets to the queue.
<span class="fc bfc" id="L119" title="All 2 branches covered.">            if (Request.isQuorum(request.type)) {</span>
<span class="fc" id="L120">                zks.getZKDatabase().addCommittedProposal(request);</span>
            }
<span class="pc" id="L122">        }</span>

<span class="fc bfc" id="L124" title="All 4 branches covered.">        if (request.hdr != null &amp;&amp; request.hdr.getType() == OpCode.closeSession) {</span>
<span class="fc" id="L125">            ServerCnxnFactory scxn = zks.getServerCnxnFactory();</span>
            // this might be possible since
            // we might just be playing diffs from the leader
<span class="pc bpc" id="L128" title="1 of 4 branches missed.">            if (scxn != null &amp;&amp; request.cnxn == null) {</span>
                // calling this if we have the cnxn results in the client's
                // close session response being lost - we've already closed
                // the session/socket here before we can send the closeSession
                // in the switch block below
<span class="fc" id="L133">                scxn.closeSession(request.sessionId);</span>
<span class="fc" id="L134">                return;</span>
            }
        }

<span class="fc bfc" id="L138" title="All 2 branches covered.">        if (request.cnxn == null) {</span>
<span class="fc" id="L139">            return;</span>
        }
<span class="fc" id="L141">        ServerCnxn cnxn = request.cnxn;</span>

<span class="fc" id="L143">        String lastOp = &quot;NA&quot;;</span>
<span class="fc" id="L144">        zks.decInProcess();</span>
<span class="fc" id="L145">        Code err = Code.OK;</span>
<span class="fc" id="L146">        Record rsp = null;</span>
<span class="fc" id="L147">        boolean closeSession = false;</span>
        try {
<span class="fc bfc" id="L149" title="All 4 branches covered.">            if (request.hdr != null &amp;&amp; request.hdr.getType() == OpCode.error) {</span>
<span class="fc" id="L150">                throw KeeperException.create(KeeperException.Code.get((</span>
<span class="fc" id="L151">                        (ErrorTxn) request.txn).getErr()));</span>
            }

<span class="fc" id="L154">            KeeperException ke = request.getException();</span>
<span class="pc bpc" id="L155" title="1 of 4 branches missed.">            if (ke != null &amp;&amp; request.type != OpCode.multi) {</span>
<span class="nc" id="L156">                throw ke;</span>
            }

<span class="pc bpc" id="L159" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L160">                LOG.debug(&quot;{}&quot;,request);</span>
            }
<span class="pc bpc" id="L162" title="2 of 17 branches missed.">            switch (request.type) {</span>
            case OpCode.ping: {
<span class="fc" id="L164">                zks.serverStats().updateLatency(request.createTime);</span>

<span class="fc" id="L166">                lastOp = &quot;PING&quot;;</span>
<span class="fc" id="L167">                cnxn.updateStatsForResponse(request.cxid, request.zxid, lastOp,</span>
<span class="fc" id="L168">                        request.createTime, System.currentTimeMillis());</span>

<span class="fc" id="L170">                cnxn.sendResponse(new ReplyHeader(-2,</span>
<span class="fc" id="L171">                        zks.getZKDatabase().getDataTreeLastProcessedZxid(), 0), null, &quot;response&quot;);</span>
<span class="fc" id="L172">                return;</span>
            }
            case OpCode.createSession: {
<span class="fc" id="L175">                zks.serverStats().updateLatency(request.createTime);</span>

<span class="fc" id="L177">                lastOp = &quot;SESS&quot;;</span>
<span class="fc" id="L178">                cnxn.updateStatsForResponse(request.cxid, request.zxid, lastOp,</span>
<span class="fc" id="L179">                        request.createTime, System.currentTimeMillis());</span>

<span class="fc" id="L181">                zks.finishSessionInit(request.cnxn, true);</span>
<span class="fc" id="L182">                return;</span>
            }
            case OpCode.multi: {
<span class="fc" id="L185">                lastOp = &quot;MULT&quot;;</span>
<span class="fc" id="L186">                rsp = new MultiResponse() ;</span>

<span class="fc bfc" id="L188" title="All 2 branches covered.">                for (ProcessTxnResult subTxnResult : rc.multiResult) {</span>

                    OpResult subResult ;

<span class="pc bpc" id="L192" title="1 of 6 branches missed.">                    switch (subTxnResult.type) {</span>
                        case OpCode.check:
<span class="fc" id="L194">                            subResult = new CheckResult();</span>
<span class="fc" id="L195">                            break;</span>
                        case OpCode.create:
<span class="fc" id="L197">                            subResult = new CreateResult(subTxnResult.path);</span>
<span class="fc" id="L198">                            break;</span>
                        case OpCode.delete:
<span class="fc" id="L200">                            subResult = new DeleteResult();</span>
<span class="fc" id="L201">                            break;</span>
                        case OpCode.setData:
<span class="fc" id="L203">                            subResult = new SetDataResult(subTxnResult.stat);</span>
<span class="fc" id="L204">                            break;</span>
                        case OpCode.error:
<span class="fc" id="L206">                            subResult = new ErrorResult(subTxnResult.err) ;</span>
<span class="fc" id="L207">                            break;</span>
                        default:
<span class="nc" id="L209">                            throw new IOException(&quot;Invalid type of op&quot;);</span>
                    }

<span class="fc" id="L212">                    ((MultiResponse)rsp).add(subResult);</span>
<span class="fc" id="L213">                }</span>

<span class="fc" id="L215">                break;</span>
            }
            case OpCode.create: {
<span class="fc" id="L218">                lastOp = &quot;CREA&quot;;</span>
<span class="fc" id="L219">                rsp = new CreateResponse(rc.path);</span>
<span class="fc" id="L220">                err = Code.get(rc.err);</span>
<span class="fc" id="L221">                break;</span>
            }
            case OpCode.delete: {
<span class="fc" id="L224">                lastOp = &quot;DELE&quot;;</span>
<span class="fc" id="L225">                err = Code.get(rc.err);</span>
<span class="fc" id="L226">                break;</span>
            }
            case OpCode.setData: {
<span class="fc" id="L229">                lastOp = &quot;SETD&quot;;</span>
<span class="fc" id="L230">                rsp = new SetDataResponse(rc.stat);</span>
<span class="fc" id="L231">                err = Code.get(rc.err);</span>
<span class="fc" id="L232">                break;</span>
            }
            case OpCode.setACL: {
<span class="fc" id="L235">                lastOp = &quot;SETA&quot;;</span>
<span class="fc" id="L236">                rsp = new SetACLResponse(rc.stat);</span>
<span class="fc" id="L237">                err = Code.get(rc.err);</span>
<span class="fc" id="L238">                break;</span>
            }
            case OpCode.closeSession: {
<span class="fc" id="L241">                lastOp = &quot;CLOS&quot;;</span>
<span class="fc" id="L242">                closeSession = true;</span>
<span class="fc" id="L243">                err = Code.get(rc.err);</span>
<span class="fc" id="L244">                break;</span>
            }
            case OpCode.sync: {
<span class="fc" id="L247">                lastOp = &quot;SYNC&quot;;</span>
<span class="fc" id="L248">                SyncRequest syncRequest = new SyncRequest();</span>
<span class="fc" id="L249">                ByteBufferInputStream.byteBuffer2Record(request.request,</span>
                        syncRequest);
<span class="fc" id="L251">                rsp = new SyncResponse(syncRequest.getPath());</span>
<span class="fc" id="L252">                break;</span>
            }
            case OpCode.check: {
<span class="nc" id="L255">                lastOp = &quot;CHEC&quot;;</span>
<span class="nc" id="L256">                rsp = new SetDataResponse(rc.stat);</span>
<span class="nc" id="L257">                err = Code.get(rc.err);</span>
<span class="nc" id="L258">                break;</span>
            }
            case OpCode.exists: {
<span class="fc" id="L261">                lastOp = &quot;EXIS&quot;;</span>
                // TODO we need to figure out the security requirement for this!
<span class="fc" id="L263">                ExistsRequest existsRequest = new ExistsRequest();</span>
<span class="fc" id="L264">                ByteBufferInputStream.byteBuffer2Record(request.request,</span>
                        existsRequest);
<span class="fc" id="L266">                String path = existsRequest.getPath();</span>
<span class="pc bpc" id="L267" title="1 of 2 branches missed.">                if (path.indexOf('\0') != -1) {</span>
<span class="nc" id="L268">                    throw new KeeperException.BadArgumentsException();</span>
                }
<span class="fc" id="L270">                Stat stat = zks.getZKDatabase().statNode(path, existsRequest</span>
<span class="fc bfc" id="L271" title="All 2 branches covered.">                        .getWatch() ? cnxn : null);</span>
<span class="fc" id="L272">                rsp = new ExistsResponse(stat);</span>
<span class="fc" id="L273">                break;</span>
            }
            case OpCode.getData: {
<span class="fc" id="L276">                lastOp = &quot;GETD&quot;;</span>
<span class="fc" id="L277">                GetDataRequest getDataRequest = new GetDataRequest();</span>
<span class="fc" id="L278">                ByteBufferInputStream.byteBuffer2Record(request.request,</span>
                        getDataRequest);
<span class="fc" id="L280">                DataNode n = zks.getZKDatabase().getNode(getDataRequest.getPath());</span>
<span class="fc bfc" id="L281" title="All 2 branches covered.">                if (n == null) {</span>
<span class="fc" id="L282">                    throw new KeeperException.NoNodeException();</span>
                }
                Long aclL;
<span class="fc" id="L285">                synchronized(n) {</span>
<span class="fc" id="L286">                    aclL = n.acl;</span>
<span class="pc" id="L287">                }</span>
<span class="fc" id="L288">                PrepRequestProcessor.checkACL(zks, zks.getZKDatabase().convertLong(aclL),</span>
                        ZooDefs.Perms.READ,
                        request.authInfo);
<span class="fc" id="L291">                Stat stat = new Stat();</span>
<span class="fc" id="L292">                byte b[] = zks.getZKDatabase().getData(getDataRequest.getPath(), stat,</span>
<span class="fc bfc" id="L293" title="All 2 branches covered.">                        getDataRequest.getWatch() ? cnxn : null);</span>
<span class="fc" id="L294">                rsp = new GetDataResponse(b, stat);</span>
<span class="fc" id="L295">                break;</span>
            }
            case OpCode.setWatches: {
<span class="fc" id="L298">                lastOp = &quot;SETW&quot;;</span>
<span class="fc" id="L299">                SetWatches setWatches = new SetWatches();</span>
                // XXX We really should NOT need this!!!!
<span class="fc" id="L301">                request.request.rewind();</span>
<span class="fc" id="L302">                ByteBufferInputStream.byteBuffer2Record(request.request, setWatches);</span>
<span class="fc" id="L303">                long relativeZxid = setWatches.getRelativeZxid();</span>
<span class="fc" id="L304">                zks.getZKDatabase().setWatches(relativeZxid, </span>
<span class="fc" id="L305">                        setWatches.getDataWatches(), </span>
<span class="fc" id="L306">                        setWatches.getExistWatches(),</span>
<span class="fc" id="L307">                        setWatches.getChildWatches(), cnxn);</span>
<span class="fc" id="L308">                break;</span>
            }
            case OpCode.getACL: {
<span class="fc" id="L311">                lastOp = &quot;GETA&quot;;</span>
<span class="fc" id="L312">                GetACLRequest getACLRequest = new GetACLRequest();</span>
<span class="fc" id="L313">                ByteBufferInputStream.byteBuffer2Record(request.request,</span>
                        getACLRequest);
<span class="fc" id="L315">                Stat stat = new Stat();</span>
<span class="fc" id="L316">                List&lt;ACL&gt; acl = </span>
<span class="fc" id="L317">                    zks.getZKDatabase().getACL(getACLRequest.getPath(), stat);</span>
<span class="fc" id="L318">                rsp = new GetACLResponse(acl, stat);</span>
<span class="fc" id="L319">                break;</span>
            }
            case OpCode.getChildren: {
<span class="fc" id="L322">                lastOp = &quot;GETC&quot;;</span>
<span class="fc" id="L323">                GetChildrenRequest getChildrenRequest = new GetChildrenRequest();</span>
<span class="fc" id="L324">                ByteBufferInputStream.byteBuffer2Record(request.request,</span>
                        getChildrenRequest);
<span class="fc" id="L326">                DataNode n = zks.getZKDatabase().getNode(getChildrenRequest.getPath());</span>
<span class="fc bfc" id="L327" title="All 2 branches covered.">                if (n == null) {</span>
<span class="fc" id="L328">                    throw new KeeperException.NoNodeException();</span>
                }
                Long aclG;
<span class="fc" id="L331">                synchronized(n) {</span>
<span class="fc" id="L332">                    aclG = n.acl;</span>
                    
<span class="pc" id="L334">                }</span>
<span class="fc" id="L335">                PrepRequestProcessor.checkACL(zks, zks.getZKDatabase().convertLong(aclG), </span>
                        ZooDefs.Perms.READ,
                        request.authInfo);
<span class="fc" id="L338">                List&lt;String&gt; children = zks.getZKDatabase().getChildren(</span>
<span class="fc" id="L339">                        getChildrenRequest.getPath(), null, getChildrenRequest</span>
<span class="fc bfc" id="L340" title="All 2 branches covered.">                                .getWatch() ? cnxn : null);</span>
<span class="fc" id="L341">                rsp = new GetChildrenResponse(children);</span>
<span class="fc" id="L342">                break;</span>
            }
            case OpCode.getChildren2: {
<span class="fc" id="L345">                lastOp = &quot;GETC&quot;;</span>
<span class="fc" id="L346">                GetChildren2Request getChildren2Request = new GetChildren2Request();</span>
<span class="fc" id="L347">                ByteBufferInputStream.byteBuffer2Record(request.request,</span>
                        getChildren2Request);
<span class="fc" id="L349">                Stat stat = new Stat();</span>
<span class="fc" id="L350">                DataNode n = zks.getZKDatabase().getNode(getChildren2Request.getPath());</span>
<span class="fc bfc" id="L351" title="All 2 branches covered.">                if (n == null) {</span>
<span class="fc" id="L352">                    throw new KeeperException.NoNodeException();</span>
                }
                Long aclG;
<span class="fc" id="L355">                synchronized(n) {</span>
<span class="fc" id="L356">                    aclG = n.acl;</span>
<span class="pc" id="L357">                }</span>
<span class="fc" id="L358">                PrepRequestProcessor.checkACL(zks, zks.getZKDatabase().convertLong(aclG), </span>
                        ZooDefs.Perms.READ,
                        request.authInfo);
<span class="fc" id="L361">                List&lt;String&gt; children = zks.getZKDatabase().getChildren(</span>
<span class="fc" id="L362">                        getChildren2Request.getPath(), stat, getChildren2Request</span>
<span class="fc bfc" id="L363" title="All 2 branches covered.">                                .getWatch() ? cnxn : null);</span>
<span class="fc" id="L364">                rsp = new GetChildren2Response(children, stat);</span>
<span class="fc" id="L365">                break;</span>
            }
            }
<span class="nc" id="L368">        } catch (SessionMovedException e) {</span>
            // session moved is a connection level error, we need to tear
            // down the connection otw ZOOKEEPER-710 might happen
            // ie client on slow follower starts to renew session, fails
            // before this completes, then tries the fast follower (leader)
            // and is successful, however the initial renew is then 
            // successfully fwd/processed by the leader and as a result
            // the client and leader disagree on where the client is most
            // recently attached (and therefore invalid SESSION MOVED generated)
<span class="nc" id="L377">            cnxn.sendCloseSession();</span>
<span class="nc" id="L378">            return;</span>
<span class="fc" id="L379">        } catch (KeeperException e) {</span>
<span class="fc" id="L380">            err = e.code();</span>
<span class="nc" id="L381">        } catch (Exception e) {</span>
            // log at error level as we are returning a marshalling
            // error to the user
<span class="nc" id="L384">            LOG.error(&quot;Failed to process &quot; + request, e);</span>
<span class="nc" id="L385">            StringBuilder sb = new StringBuilder();</span>
<span class="nc" id="L386">            ByteBuffer bb = request.request;</span>
<span class="nc" id="L387">            bb.rewind();</span>
<span class="nc bnc" id="L388" title="All 2 branches missed.">            while (bb.hasRemaining()) {</span>
<span class="nc" id="L389">                sb.append(Integer.toHexString(bb.get() &amp; 0xff));</span>
            }
<span class="nc" id="L391">            LOG.error(&quot;Dumping request buffer: 0x&quot; + sb.toString());</span>
<span class="nc" id="L392">            err = Code.MARSHALLINGERROR;</span>
<span class="fc" id="L393">        }</span>

<span class="fc" id="L395">        long lastZxid = zks.getZKDatabase().getDataTreeLastProcessedZxid();</span>
<span class="fc" id="L396">        ReplyHeader hdr =</span>
<span class="fc" id="L397">            new ReplyHeader(request.cxid, lastZxid, err.intValue());</span>

<span class="fc" id="L399">        zks.serverStats().updateLatency(request.createTime);</span>
<span class="fc" id="L400">        cnxn.updateStatsForResponse(request.cxid, lastZxid, lastOp,</span>
<span class="fc" id="L401">                    request.createTime, System.currentTimeMillis());</span>

        try {
<span class="fc" id="L404">            cnxn.sendResponse(hdr, rsp, &quot;response&quot;);</span>
<span class="fc bfc" id="L405" title="All 2 branches covered.">            if (closeSession) {</span>
<span class="fc" id="L406">                cnxn.sendCloseSession();</span>
            }
<span class="nc" id="L408">        } catch (IOException e) {</span>
<span class="nc" id="L409">            LOG.error(&quot;FIXMSG&quot;,e);</span>
<span class="fc" id="L410">        }</span>
<span class="fc" id="L411">    }</span>

    public void shutdown() {
        // we are the final link in the chain
<span class="fc" id="L415">        LOG.info(&quot;shutdown of request processor complete&quot;);</span>
<span class="fc" id="L416">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>